.\" DAL DaGetRegRep(3) manpage
.\"
.\"
.\" +============================================+
.\" |  Author:          Yury Georgievskiy, CERN  |
.\" |  Creation date:   14.09.2007               |
.\" +============================================+
.\"
.\"
.TH DAGETREGREP "3" "January 2008" "Driver Access Library" "DAL User's Manual"
.SH NAME
DaGetRegRep \- multiple read of a module register
.SH SYNOPSIS
.B int DaGetRegRep(HANDLE \fIhndl\fB, int \fIrId\fB, int \fIelOf\fB, int \fIrcnt\fB, void* \fIbuf\fB, int \fIbsz\fB);
.SH DESCRIPTION
The \fIDaGetRegRep()\fR function performs multiple read on the given module
register (or one of the elements in the \fBspecific\fR register) \fIrId\fR and
put obtained data in the user buffer \fIbuf\fR.
.sp 0
In case of \fBspecific\fR register (i.e. one that consists of several elements)
- only one register element can be read repeatedly by this function. If you
want to read multiple elements - this function should be called several times
for each of the element you want to read.
.sp 0
In case of a \fBnormal\fR register (one that consist of one element)
- \fIelOf\fR should be zero, as there is only one element.
.sp 0
Only real module registers support repetitive r/w operations. I.e. \fIfunction
is not working on \fBextraneous\fI registers, \fBservice\fI registers and last
history of \fBwrite-only\fI registers\fR. Buffer \fIbuf\fR should be big enough
to hold obtained data.
.TP
.I hndl
- lib handle, returned by \fIDaEnableAccess()\fR call
.TP
.I rId
- register ID that should be examine. ID of each Module register can be
found in \fI<ModuleName>RegId.h\fR file, which is located
in a standart include directory of a given Module:
\fI/ps/local/$(CPU)/drvrutil/include/<ModuleName>include\fR.
.TP
.I elOf
- element offset inside the register (\fIexpressed in element index!\fR)
.TP
.I rcnt
- how many times register element should be read (min 1)
.TP
.I buf
- user buffer to put data in
.TP
.I bsz
- user buffer size in bytes
.SH RETURN VALUE
On success, how many times register was read is returned (Min \fI1\fR).
.TP
In case of failure one of the following:
.TP
.B -DA_ERR_B2S
- provided buffer is not big enough to hold the results.
.TP
.B -DA_ERR_BAD_HANDLE
- provided handle \fIhndl\fR is bad.
.TP
.B -DA_ERR_NO_REG
- no such register.
.TP
.B -DA_ERR_INT_ERR
- can't get register value for some reason. Information is printed out on the
stderr if \fBDA_DBG_ERR_INFO\fR debug flag is set (see \fIDaDbgFlag()\fR for
more info about debug flags)
.TP
.B -DA_ERR_NOT_INIT
- library was not initialized, i.e. \fIDaEnableAccess()\fR was not called
.TP
.B -DA_ERR_NOT_ALLOW
- repetitive read is not allowed for \fIrId\fR register
.TP
.B -DA_ERR_REG_BOUNDS
- required register element is beyond register bounds or repetitive read
counter \fIrcnt\fR is zero
.SH AUTHOR
Written by Yury Georgievskiy (ygeorgie (at) gmail.com)
.SH SEE ALSO
.BR driverGen (8),
.BR modinst (8),
.BR moduninst (8),
.BR dal (3),
.BR DaEnableAccess (3),
.BR DaDisableAccess (3),
.BR DaSetDefAM (3),
.BR DaGetDefAM (3),
.BR DaGetNodeFd (3),
.BR DaGetRegister (3),
.BR DaSetRegister (3),
.BR DaSetRegChunk (3),
.BR DaGetRegDepth (3),
.BR DaGetRegSize (3),
.BR DaSetRegRep (3),
.BR DaGetRegAccessRights (3),
.BR DaGetRegName (3),
.BR DaDrvrVers (3),
.BR DaLibVers (3),
.BR DaDbgFlag (3),
.BR DaGetErrCode (3),
.BR DaUserEntryPoint (3)
